## qemacs 0.4.1.cvs.20190929

=== Makefile ===
# QEmacs, tiny but powerful multimode editor
#
# Copyright (c) 2000-2002 Fabrice Bellard.
# Copyright (c) 2000-2017 Charlie Gordon.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

DEPTH=.

include $(DEPTH)/config.mak

ifeq (,$(V)$(VERBOSE))
    echo := @echo
    cmd  := @
else
    echo := @:
    cmd  := 
endif

ifeq ($(CC),gcc)
  CFLAGS  += -Wall -g -O2 -funsigned-char
  # do not warn about zero-length formats.
  CFLAGS   += -Wno-format-zero-length
  LDFLAGS  += -g
endif

#include local compiler configuration file
-include $(DEPTH)/cflags.mk

ifdef TARGET_GPROF
  CFLAGS  += -p
  LDFLAGS += -p
endif

#TCFLAGS := -DCONFIG_TINY -m32 $(CFLAGS) -Os
#TLDFLAGS := -m32 $(LDFLAGS)
TCFLAGS := -DCONFIG_TINY $(CFLAGS) -Os
TLDFLAGS := $(LDFLAGS)

ifdef TARGET_ARCH_X86
  #CFLAGS+=-fomit-frame-pointer
  ifeq ($(GCC_MAJOR),2)
    CFLAGS += -m386 -malign-functions=0
  else
    CFLAGS += -march=i386 -falign-functions=0
  endif
endif

DEFINES=-DHAVE_QE_CONFIG_H

########################################################
# do not modify after this

TARGETLIBS:=
TARGETS+= qe$(EXE) kmaps ligatures

OBJS:= qe.o util.o cutils.o charset.o buffer.o search.o parser.o input.o display.o hex.o \
       list.o
TOBJS:= $(OBJS)
OBJS+= extras.o variables.o

ifdef CONFIG_DARWIN
  LDFLAGS += -L/opt/local/lib/
endif

ifdef CONFIG_PNG_OUTPUT
  HTMLTOPPM_LIBS += -lpng
endif

ifdef CONFIG_DLL
  LIBS += $(DLLIBS)
  # export some qemacs symbols
  LDFLAGS += -Wl,-E
endif

ifdef CONFIG_DOC
  TARGETS += qe-doc.html
endif

ifdef CONFIG_HAIKU
  OBJS += haiku.o
  LIBS += -lbe -lstdc++
endif

ifdef CONFIG_WIN32
  OBJS+= unix.o win32.o
  TOBJS+= unix.o win32.o
#  OBJS+= printf.o
#  TOBJS+= printf.o
  LIBS+= -lmsvcrt -lgdi32 -lwsock32
  TLIBS+= -lmsvcrt -lgdi32 -lwsock32
else
  OBJS+= unix.o tty.o
  TOBJS+= unix.o tty.o
  LIBS+= $(EXTRALIBS)
endif

ifdef CONFIG_QSCRIPT
  OBJS+= qscript.o eval.o
endif

ifdef CONFIG_ALL_KMAPS
  OBJS+= kmap.o
endif

ifdef CONFIG_UNICODE_JOIN
  OBJS+= unicode_join.o arabic.o indic.o qfribidi.o
endif

# more charsets if needed
OBJS+= charsetjis.o charsetmore.o

ifdef CONFIG_ALL_MODES
  OBJS+= unihex.o bufed.o clang.o xml.o htmlsrc.o forth.o arm.o \
         lisp.o makemode.o markdown.o orgmode.o perl.o script.o \
         ebnf.o cobol.o rlang.o $(EXTRA_MODES) extra-modes.o
  ifndef CONFIG_WIN32
    OBJS+= shell.o dired.o latex-mode.o archive.o
  endif
endif

# currently not used in qemacs
ifdef CONFIG_CFB
  OBJS+= libfbf.o fbfrender.o cfb.o fbffonts.o
endif

ifdef CONFIG_HTML
  QHTML_DEPS:= libqhtml/libqhtml-$(TARGET_OS)-$(TARGET_ARCH)-$(CC).a
  QHTML_LIBS:= -L./libqhtml -lqhtml-$(TARGET_OS)-$(TARGET_ARCH)-$(CC)
  CFLAGS+= -I./libqhtml
  DEP_LIBS+= $(QHTML_DEPS)
  LIBS+= $(QHTML_LIBS)
  OBJS+= html.o docbook.o
  ifndef CONFIG_WIN32
    TARGETLIBS+= libqhtml
    TARGETS+= html2png$(EXE)
  endif
endif

ifdef CONFIG_FFMPEG
  OBJS+= video.o image.o
  DEP_LIBS+= $(FFMPEG_LIBDIR)/libavcodec/libavcodec.a $(FFMPEG_LIBDIR)/libavformat/libavformat.a
  LIBS+= -L$(FFMPEG_LIBDIR)/libavcodec -L$(FFMPEG_LIBDIR)/libavformat -lavformat -lavcodec -lz -lpthread
  DEFINES+= -I$(FFMPEG_SRCDIR)/libavcodec -I$(FFMPEG_SRCDIR)/libavformat
  TARGETS+= ffplay$(EXE)
endif

ifdef CONFIG_X11
  XCFLAGS:= -DCONFIG_X11 $(CFLAGS)
  TARGETS += xqe$(EXE)
  XOBJS := x11.o
  XLIBS :=
  ifdef CONFIG_XRENDER
    XLIBS += -lXrender
  endif
  ifdef CONFIG_XV
    XLIBS += -lXv
  endif
  ifdef CONFIG_XSHM
    XLIBS += -lXext
  endif
  XLIBS += -lX11 $(DLLIBS)
  XLDFLAGS := $(LDFLAGS)
  ifdef CONFIG_DARWIN
    XLDFLAGS += -L/opt/X11/lib/
  endif
endif

ifndef CONFIG_TINY
  TARGETS += tqe$(EXE)
endif

XOBJS:= $(OBJS) $(XOBJS)

ifdef CONFIG_INIT_CALLS
  # must be the last object
  OBJS+= qeend.o
  TOBJS+= qeend.o
  XOBJS+= qeend.o
endif

SRCS:= $(OBJS:.o=.c)
TSRCS:= $(TOBJS:.o=.c)
XSRCS:= $(XOBJS:.o=.c)

DEPENDS:= qe.h config.h cutils.h display.h qestyles.h variables.h config.mak
DEPENDS:= $(addprefix $(DEPTH)/, $(DEPENDS))

OBJS_DIR:= $(DEPTH)/.objs-$(TARGET_OS)-$(TARGET_ARCH)-$(CC)
CFLAGS+= -I$(OBJS_DIR)
OBJS:= $(addprefix $(OBJS_DIR)/, $(OBJS))

XOBJS_DIR:= $(DEPTH)/.xobjs-$(TARGET_OS)-$(TARGET_ARCH)-$(CC)
XCFLAGS+= -I$(XOBJS_DIR)
XOBJS:= $(addprefix $(XOBJS_DIR)/, $(XOBJS))

TOBJS_DIR:= $(DEPTH)/.tobjs-$(TARGET_OS)-$(TARGET_ARCH)-$(CC)
TCFLAGS+= -I$(TOBJS_DIR)
TOBJS:= $(addprefix $(TOBJS_DIR)/, $(TOBJS))

$(shell mkdir -p $(OBJS_DIR) $(TOBJS_DIR) $(XOBJS_DIR))

#
# Dependencies
#
all: $(TARGETLIBS) $(TARGETS)

libqhtml: force
	$(MAKE) -C libqhtml all

qe_g$(EXE): $(OBJS) $(DEP_LIBS)
	$(echo) LD $@
	$(cmd)  $(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

qe$(EXE): qe_g$(EXE) Makefile
	@rm -f $@
	cp $< $@
	-$(STRIP) $@
	@ls -l $@
	@echo `size $@` `wc -c $@` qe $(OPTIONS) \
		| cut -d ' ' -f 7-10,13,15-40 >> STATS

#
# X11 version of QEmacs
#
xqe_g$(EXE): $(XOBJS) $(DEP_LIBS)
	$(echo) LD $@
	$(cmd)  $(CC) $(XLDFLAGS) -o $@ $^ $(XLIBS)

xqe$(EXE): xqe_g$(EXE) Makefile
	@rm -f $@
	cp $< $@
	-$(STRIP) $@
	@ls -l $@
	@echo `size $@` `wc -c $@` xqe $(OPTIONS) \
		| cut -d ' ' -f 7-10,13,15-40 >> STATS

#
# Tiny version of QEmacs
#
tqe_g$(EXE): $(TOBJS)
	$(echo) LD $@
	$(cmd)  $(CC) $(TLDFLAGS) -o $@ $^ $(TLIBS)

tqe$(EXE): tqe_g$(EXE) Makefile
	@rm -f $@
	cp $< $@
	-$(STRIP) $@
	@ls -l $@
	@echo `size $@` `wc -c $@` tqe $(OPTIONS) \
		| cut -d ' ' -f 7-10,13,15-40 >> STATS

t1qe_g$(EXE): tqe.c $(TSRCS) Makefile
	$(echo) CC -o $@ $<
	$(cmd)  $(CC) $(DEFINES) $(CFLAGS) $(TLDFLAGS) -o $@ $< $(TLIBS)

t1qe$(EXE): t1qe_g$(EXE) Makefile
	@rm -f $@
	cp $< $@
	-$(STRIP) $@
	@ls -l $@
	@echo `size $@` `wc -c $@` t1qe $(OPTIONS) \
		| cut -d ' ' -f 7-10,13,15-40 >> STATS

ffplay$(EXE): qe$(EXE) Makefile
	ln -sf $< $@

ifndef CONFIG_INIT_CALLS
$(OBJS_DIR)/qe.o: $(OBJS_DIR)/modules.txt
$(XOBJS_DIR)/qe.o: $(XOBJS_DIR)/modules.txt
$(TOBJS_DIR)/qe.o: $(TOBJS_DIR)/modules.txt
endif

$(OBJS_DIR)/modules.txt: $(SRCS) Makefile
	@echo creating $@
	@echo '/* This file was generated automatically */' > $@
	@grep -h ^qe_module_init $(SRCS) | \
            sed s/qe_module_init/qe_module_declare/ >> $@

$(XOBJS_DIR)/modules.txt: $(XSRCS) Makefile
	@echo creating $@
	@echo '/* This file was generated automatically */' > $@
	@grep -h ^qe_module_init $(XSRCS) | \
            sed s/qe_module_init/qe_module_declare/ >> $@

$(TOBJS_DIR)/modules.txt: $(TSRCS) Makefile
	@echo creating $@
	@echo '/* This file was generated automatically */' > $@
	@grep -h ^qe_module_init $(TSRCS) | \
            sed s/qe_module_init/qe_module_declare/ >> $@

$(OBJS_DIR)/cfb.o: cfb.c cfb.h fbfrender.h
$(OBJS_DIR)/charset.o: charset.c unicode_width.h
$(OBJS_DIR)/charsetjis.o: charsetjis.c charsetjis.def
$(OBJS_DIR)/fbfrender.o: fbfrender.c fbfrender.h libfbf.h
$(OBJS_DIR)/qe.o: qe.c parser.c qeconfig.h qfribidi.h variables.h
$(OBJS_DIR)/qfribidi.o: qfribidi.c qfribidi.h
$(OBJS_DIR)/clang.o: clang.c rust.c swift.c icon.c groovy.c virgil.c

$(XOBJS_DIR)/cfb.o: cfb.c cfb.h fbfrender.h
$(XOBJS_DIR)/charset.o: charset.c unicode_width.h
$(XOBJS_DIR)/charsetjis.o: charsetjis.c charsetjis.def
$(XOBJS_DIR)/fbfrender.o: fbfrender.c fbfrender.h libfbf.h
$(XOBJS_DIR)/qe.o: qe.c parser.c qeconfig.h qfribidi.h variables.h
$(XOBJS_DIR)/qfribidi.o: qfribidi.c qfribidi.h
$(XOBJS_DIR)/clang.o: clang.c rust.c swift.c icon.c groovy.c virgil.c

$(TOBJS_DIR)/cfb.o: cfb.c cfb.h fbfrender.h
$(TOBJS_DIR)/charset.o: charset.c unicode_width.h
$(TOBJS_DIR)/charsetjis.o: charsetjis.c charsetjis.def
$(TOBJS_DIR)/fbfrender.o: fbfrender.c fbfrender.h libfbf.h
$(TOBJS_DIR)/qe.o: qe.c parser.c qeconfig.h qfribidi.h variables.h
$(TOBJS_DIR)/qfribidi.o: qfribidi.c qfribidi.h
$(TOBJS_DIR)/clang.o: clang.c swift.c

$(OBJS_DIR)/%.o: %.c $(DEPENDS) Makefile
	$(echo) CC -c $<
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  $(CC) $(DEFINES) $(CFLAGS) -o $@ -c $<

$(XOBJS_DIR)/%.o: %.c $(DEPENDS) Makefile
	$(echo) CC -DCONFIG_X11 -c $<
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  $(CC) $(DEFINES) $(XCFLAGS) -o $@ -c $<

$(TOBJS_DIR)/%.o: %.c $(DEPENDS) Makefile
	$(echo) CC -DCONFIG_TINY -c $<
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  $(CC) $(DEFINES) $(TCFLAGS) -o $@ -c $<

$(OBJS_DIR)/haiku.o: haiku.cpp $(DEPENDS) Makefile
	$(echo) CPP -c $<
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  g++ $(DEFINES) $(CFLAGS) -Wno-multichar -o $@ -c $<

$(XOBJS_DIR)/haiku.o: haiku.cpp $(DEPENDS) Makefile
	$(echo) CPP -c -DCONFIG_X11 $<
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  g++ $(DEFINES) $(XCFLAGS) -Wno-multichar -o $@ -c $<

$(TOBJS_DIR)/haiku.o: haiku.cpp $(DEPENDS) Makefile
	$(echo) CPP -DCONFIG_TINY -c $<
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  g++ $(DEFINES) $(TCFLAGS) -Wno-multichar -o $@ -c $<

#debugging targets
%.s: %.c $(DEPENDS) Makefile
	$(CC) $(DEFINES) $(CFLAGS) -o $@ -S $<

%.s: %.cpp $(DEPENDS) Makefile
	g++ $(DEFINES) $(CFLAGS) -Wno-multichar -o $@ -S $<

#
# Test for bidir algorithm
#
qfribidi$(EXE): qfribidi.c cutils.c
	$(echo) CC -o $@ $^
	$(cmd)  $(HOST_CC) $(CFLAGS) -DTEST -o $@ $^

#
# build ligature table
#
ligtoqe$(EXE): ligtoqe.c cutils.c
	$(echo) CC -o $@ $^
	$(cmd)  $(HOST_CC) $(CFLAGS) -o $@ $^

ifdef BUILD_ALL
ligatures: ligtoqe$(EXE) unifont.lig
	./ligtoqe unifont.lig $@
endif

#
# Key maps build (Only useful if you want to build your own maps from yudit maps)
#
KMAPS=Arabic.kmap ArmenianEast.kmap ArmenianWest.kmap Chinese-CJ.kmap       \
      Cyrillic.kmap Czech.kmap DE-RU.kmap Danish.kmap Dutch.kmap            \
      Esperanto.kmap Ethiopic.kmap French.kmap Georgian.kmap German.kmap    \
      Greek.kmap GreekMono.kmap Guarani.kmap HebrewP.kmap Hungarian.kmap    \
      KOI8_R.kmap Lithuanian.kmap Mnemonic.kmap Polish.kmap Russian.kmap    \
      SGML.kmap TeX.kmap Troff.kmap VNtelex.kmap                            \
      Vietnamese.kmap XKB_iso8859-4.kmap                                    \
      DanishAlternate.kmap GreekBible.kmap Polytonic.kmap Spanish.kmap      \
      Thai.kmap VietnameseTelex.kmap Welsh.kmap                             \
      Hebrew.kmap HebrewIsraeli.kmap HebrewP.kmap Israeli.kmap Yiddish.kmap \
      Kana.kmap
#     Hangul.kmap Hangul2.kmap Hangul3.kmap Unicode2.kmap
#KMAPS_DIR=$(datadir)/yudit/data
KMAPS_DIR=kmap
KMAPS:=$(addprefix $(KMAPS_DIR)/, $(KMAPS))

kmaptoqe$(EXE): kmaptoqe.c cutils.c
	$(echo) CC -o $@ $^
	$(cmd)  $(HOST_CC) $(CFLAGS) -o $@ $^

ifdef BUILD_ALL
kmaps: kmaptoqe$(EXE) $(KMAPS) Makefile
	./kmaptoqe $@ $(KMAPS)
endif

#
# Code pages (only useful to add your own code pages)
#
CP=  8859-2.TXT   8859-3.TXT   8859-4.TXT   8859-5.TXT   8859-6.TXT  \
     8859-7.TXT   8859-8.TXT   8859-9.TXT   8859-10.TXT  8859-11.TXT \
     8859-13.TXT  8859-14.TXT  8859-15.TXT  8859-16.TXT              \
     CP437.TXT    CP737.TXT    CP850.TXT    CP852.TXT    CP866.TXT   \
     CP1125.TXT   CP1250.TXT   CP1251.TXT   CP1252.TXT   CP1256.TXT  \
     CP1257.TXT   MAC-LATIN2.TXT MAC-ROMAN.TXT                       \
     kamen.cp     KOI8-R.TXT   koi8_u.cp    TCVN.TXT     VISCII.TXT  \
     CP037.TXT    CP424.TXT    CP500.TXT    CP875.TXT    CP1026.TXT  \
     ATARIST.TXT

CP:=$(addprefix cp/,$(CP))

JIS= JIS0208.TXT JIS0212.TXT
JIS:=$(addprefix cp/,$(JIS))

cptoqe$(EXE): cptoqe.c cutils.c
	$(echo) CC $^
	$(cmd)  $(HOST_CC) $(CFLAGS) -o $@ $^

jistoqe$(EXE): jistoqe.c cutils.c
	$(echo) CC $^
	$(cmd)  $(HOST_CC) $(CFLAGS) -o $@ $^

ifdef BUILD_ALL
charsetmore.c: cp/cpdata.txt $(CP) cptoqe$(EXE) Makefile
	./cptoqe -i cp/cpdata.txt $(CP) > $@

=== libqhtml/Makefile ===
# Libqhtml tiny HTML/CSS rendering library for QEmacs
#
# Copyright (c) 2000-2002 Fabrice Bellard.
# Copyright (c) 2000-2017 Charlie Gordon.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

DEPTH=..

include $(DEPTH)/config.mak

ifeq (,$(V)$(VERBOSE))
    echo  := @echo
    cmd   := @
else
    echo  := @:
    cmd   := 
endif

ifeq ($(CC),gcc)
  CFLAGS   += -Wall -g -O2 -funsigned-char
  # do not warn about zero-length formats.
  CFLAGS   += -Wno-format-zero-length
  LDFLAGS  := -g
endif

#include local compiler configuration file
-include $(DEPTH)/cflags.mk

ifdef TARGET_GPROF
  CFLAGS  += -p
  LDFLAGS += -p
endif

ifdef TARGET_ARCH_X86
  #CFLAGS+=-fomit-frame-pointer
  ifeq ($(GCC_MAJOR),2)
    CFLAGS+=-m386 -malign-functions=0
  else
    CFLAGS+=-march=i386 -falign-functions=0
  endif
endif

CFLAGS+=-I$(DEPTH)

LIB= libqhtml-$(TARGET_OS)-$(TARGET_ARCH)-$(CC).a
OBJS= css.o xmlparse.o cssparse.o html_style.o docbook_style.o

DEPENDS:= qe.h config.h cutils.h display.h qestyles.h config.mak
DEPENDS:= $(addprefix $(DEPTH)/, $(DEPENDS))

OBJS_DIR:= $(DEPTH)/.objs-$(TARGET_OS)-$(TARGET_ARCH)-$(CC)/libqhtml
OBJS:= $(addprefix $(OBJS_DIR)/, $(OBJS))

$(shell mkdir -p $(OBJS_DIR))

#
# Dependencies
#
all: $(LIB)

$(LIB): $(OBJS) Makefile
	@rm -f $@
	$(AR) rc $@ $(OBJS)

$(OBJS_DIR)/%.o: %.c $(DEPENDS) Makefile
	$(echo) CC -c $<
	$(cmd)  $(CC) $(DEFINES) $(CFLAGS) -o $@ -c $<

#
# build default style sheet file
#
csstoqe$(EXE): csstoqe.c Makefile
	$(echo) CC -o $@ $<
	$(cmd)  $(HOST_CC) $(CFLAGS) -o $@ $<

html_style.c: html.css csstoqe$(EXE) Makefile
	./csstoqe html_style < $< > $@

docbook_style.c: docbook.css csstoqe$(EXE) Makefile
	./csstoqe docbook_style < $< > $@

clean:
	rm -rf *.dSYM $(OBJS_DIR)
	rm -f *~ *.o *.a *.exe *_g TAGS gmon.out core *.exe.stackdump \
          csstoqe html_style.c docbook_style.c

distclean: clean

## qemacs 0.4.1.cvs.20190929-1

=== debian/changelog ===
qemacs (0.4.1.cvs.20190929-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- sunshavi <sunshavi@yahoo.com>  Sun, 29 Sep 2019 16:36:34 +0000

=== debian/control ===
Source: qemacs
Section: user/utilities
Priority: optional
Maintainer: sunshavi <sunshavi@yahoo.com>
Build-Depends: debhelper, autotools-dev, libxv-dev, libxrender-dev
Standards-Version: 3.7.3
Homepage: http://bellard.org/qemacs/

Package: qemacs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Small emacs clone editor with HTML and DocBook editing support
 compiled from cvs on 20190929
 QEmacs (for Quick Emacs) is a very small but powerful editor with an
 Emacs look and feel. Its features include:
 .
  * "All" Emacs common features,
  * Works on any VT100 terminals without termcap,
  * X11 support, with multiple simultaneous proportional fonts. Xft extension
    supported for anti aliased font display.
  * Highly optimized handling of huge files,
  * Full UTF8 support, including Unicode-conformant bidirectional editing,
    with Arabic and Indic scripts handling (in progress),
  * WYSIWYG HTML/XML/CSS2 mode graphical editing, with lynx-like rendering
    for VT100 terminals,
  * WYSIWYG DocBook mode based on XML/CSS2 renderer,
  * C mode with coloring with immediate update and emacs-like auto-indent,
  * Interactive-shell mode using colorized VT100 emulation,
  * Compile mode with next/prev error,
  * Input methods for most languages (from the Yudit editor) including Chinese,
  * X Input methods,
  * Hexadecimal editing mode with insertion and block commands,
  * Unicode hexa editing of UTF8 files,
  * UTF8 VT100 support with double width glyphs,
  * Small (full version is 150KB big).
 .
 Further information is available at <URL: http://www.qemacs.org/>
XB-Maemo-Display-Name: QEmacs
XB-Maemo-Icon-26:
 iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAABGdBTUEAAK/INwWK
 6QAAAAZiS0dEAP8A/wD/oL2nkwAAAAlwSFlzAAAASAAAAEgARslrPgAAAAl2cEFn
 AAAAMAAAADAAzu6MVwAAEYhJREFUaN6dmmmMXWd5x3/Pe9a7zh2Px+Px7B6veAtJ
 nNRJaElB0GK3lJAYqKCqqkq0H6q2Qq2IKioVaCtUiS+t+gm1VCQscQIqtURJ6iyY
 YDsk3uNl7HFm8ez73P2e5e2Hc+6dO44TEl7p1T1zl3P//+f5P9t7R3if6+gfPAei
 AXFADwKHgIeAPUAP0A5Y8dtDDcvAFHAdOAOcAi5qWBHg2I8ef78Q1i15z8AfOwYB
 oGgDPgw8FoPvAuzmOzXfVK+7kABY1HAROA4c13ALCJ/9NYm8JwJHHzsGkAV+H/gi
 cB+QaNxANEoJhhKUoRABkejWWmt0CEGoCQNNGGp0RCYEbmn4HvAfBYyRFAHvl8i7
 EnjisWfRiCjC+4Angd8VdKL+KRFQSjBNhWUpTNPANCMSSuI3aAh1BN73QzwvpFYL
 8P2IDJoQ5BLwL8APgfIz74PEOxL4TGR1B/g86K8AfeuBg2kqbNvAtg0s28A0FYYh
 GIZCqbVbaw1hqAliErVaQLUSUC771GoBaBCRIsh/AV8HpkB45kef/vUIfObTzwBk
 0PwNwl8BGdCxNMAwIuCOswbeshSGEW8lKENoaXFJpW1c10Qk8hSAEgGBSsVneqrA
 reFl5uZKaI0W+AnIl0Bfi0i8uzfMdwQPX0f4c9BWHXgdhO0YOI6J0wDfTEBQKtqW
 bZDJOLS2urS2Jsi1JshkHRzHQClBhxrPC5mbK3LylTFOvjIq5UrwCUHngC+Cvvy+
 PBCDt4G/A74sou07tW7bBo5rYtsmjhNdW5bCjGUjCpRaL6EoHATLVqSSNu2bUvQP
 5Ni8ORO9T8DzQp7/35sc/+8h/EADvAT8CTAC8MwPn7grAWMN/A9wTYUf6j8S+AcR
 ks3gDSOyvOuauK7F1sFW7j/Yxf4DHezctZG+/hwdmzO0tiZIpWxs22wEtsRkAl9T
 KNaYmSkwOrpC24YELa0uYagxDKGzM8vw8ALz8yVEZADYCJwAqm9ePfbuEhKgGoQH
 RfhKLKEGeGVEWcaxDWzLYEtXho99fBstORcRiXc9dWoCX+MHIV4toFLxqVR9qhWf
 ajWgWvUJQ43jGLTkXLTWoDWhFlJpi61bW7kxtABo0HJUw/kQ+ebRx47pu3nBBPjs
 4z8ASAN/Cwwga24XJRiGYFpxprEUGza4JJM2YVgPbI2IoOJYMU3BskySCZOWFned
 UHUIGo0SQaPjv6N6IQiGGX1fEACibdHylwp9Enjtbh5QMXiAI8DhOEFAbFklkXwi
 OSgsyyCfr1Gt+sgdSUyjY+YRqCCsF7J46zgZENUGXX89SqMUSzUmbq9GipC4hovu
 EfRfCLhxar+rhHLAn4pE1ZUYWiN4jSiA67uQrzE2usLuD7Svg48WFhfLzM8VKZd9
 fD+MjKDAsqKUm0hYuK5JImFiOyaGEkKtKRY9fv6zUd66tYTERhA0WgsIR9D6EaWM
 /3snAo+K8BB1yzdSB1FWaUqNSglaa65fn6Njc4q2tmRk7jivXzg/zepKJWp9dGTh
 MNRxIQsJg8gNhiG4CQvXMahUfG7fXuX22GpU2JAIfOwJrcn5gfeFmzeees1xpFSt
 6oC4uzL27XnCFuHLwH0N8HXri2DEsqlLyIwffV9TLnls6khjO1EyEyUsL5VZXa2u
 E9cagagSV6s+hUKN+bkSt2/nmbi9ytJiGc8PCAMdxwQgGq01i0szFEpvDTz2+L2H
 9uzZPX3q1KlJotYSBQwCD9Gs6GYWawKJL3Tjj5mZAufPT1Eu+VFONoRdu9rp6EgR
 xBYPAr1u+37Y2EG8fT8kCEJ0qJu+G3QYMDo+xI3h0zx4KJft7Oz4+Nyc/5FY8kad
 wEGQLmn6oDSBr2cIHeqoKas3Z2FIGGrGx1Y4+8YEhXwNNCQSJvsPbGZgoBURwfOC
 GHAQXXtRQ+fVAmq1gFotipVwzS4ImjDwuDF8mZu3XufwkV3s3TvAsWOnVp566tgU
 UY8mMQF5GMG5E3wdfl3D9XY4smrYsGYQhIyNr/DamdvMzRUJtcaxTT6wZxP7D2zG
 dc0YaESgVguoVQOq8XO+HxlizfUaP/AYunmBkdFLHD68j3vvHeTZZ1/jF6++WUgk
 9ARQqkvIRNgjd7F8w5U6Ah/4Gt8MUb403lInZxiKiclVVlerfGDPJvr7c5iWQW9v
 jkTC4uwbE4yPr+B5AV4tbJDxg/ps0PA1QRBw4+Ylxm5f5SMf3c0DDwzy3HOv8/OT
 Vxjo701Va27t2vX/Wa2r2hTouzM1SXPh0UIYaGq1AFHg2AbJpE06bZNM2jiugWmo
 qPJ6AdeuzbG4WGZw2wZaWhza2hIcergX+/VJLl+cplL1G/GA1rFsIv2EYcCtt64w
 MXmdD31oB488sp3jx8/z4ouXGejbwsa2nhT0GVev/bhSH5hMoO3t0ml2gCaRtOnv
 z7FtextdXVmyLQ4J14ymr0bARfFRq/oUizUqZQ/bUjiOieuaPPhgD6mUzelT4+RX
 K+vKB0CoQ0bHbzA+cZX7Dw5w6NBWTpy4wokTl+jsaKNjUw+p1CbDNNzkFz7343V1
 ILHe/Gv3tS2Dez7YyW8c6qGrO4tlRf28DqNArvtfAyhBaTDNyDNBuBb4hFGG2r+/
 g1zO5eTPRpicXI36oDjOJqdGGB17k337ujl4sIeXXrrMiRNXac2l6e7qJZPpxLHT
 Sikr63mlJgJ3sT5AImHxicM7eOjhXizbIAzDWPN1mcla1oiSNqKIG7NYhkoghBCN
 DjQaTU9vCx/7nW288tIIw8MLaK2ZmZ3grZFL7NzZwf33d/Pqq1d58cVrpFMJ+vt6
 acl24bo5DMMGxGpK6phAGKfTdU3XwQe6ePiRXgzTaAAWBFSTdnXUvYVBSD5fZX6u
 xNJymWrVp1IJ0DqKHa8WEISaStlvVOR8vgpAtZZnfmGIga1tHDjQyblzN3n55SEc
 22Kgv5vW1m4SyQ2YhoNEDdJyM1BTYAGhuanBdc1Gn+P7QaOFqFfn+vJ9zdjIEleu
 zDI+tkI+X8XzwnWK1HqtYatX5OhkQlOplLk9McS9922mJWdz4fwtXnjhKgD9fVvY
 uLGXVLIdy0ogokDrEFhpvr8JTIO0N8unDtgPol5XK0GrtdMGUYp8vsorL49w8cI0
 lYrf1Cutl2M9VOpbqYiM73m8NXKVRLJKIpFjanKGpaUKpqHYsqWdjo4+0qkObDuF
 kjj2kALo2TsJ3AT2NZ84lCs+oyPL9PS2RIS0oLRgaA2GAq352csjnPrFWDStmfEg
 r+LhRjVlMUCHUQOIQBAIBAGj4zcwrTw7d3YxMjLOCy9cob09w4H9/dh2O9lMJ46T
 QSmDRn8OcyATzQQUIq/HcbDm9lBz9uwkM9MFdKgb/YofRLta9ZmcyqN1NAoa8chp
 GHHDZygMs35OtNYAWqbCNISpqVGKpUl27+5meHiGF1+8Tj5fwfPAddtpzXXjui0Y
 ylo/cwhDwOx6AtFZ5XLzu0QJM9NFnv/pTZaWKpF+mxoxQynuvbeTbNZB4tZ43a6T
 MATTaCYkzC9MMz5xnb17e1lYyHP27A2Wlwp0bm6lr6efbLaLRKIVw7DWpp+1dUoJ
 5ebnjP17j+YFPoLQuzaJRZ9dWCgxN1diU0eadNpuSl7Cpo4UHR1pSkWPSsWHpnFw
 LR4UStEYN5eXl3jj3Gl27+7ENA1effUS4+OzbGzPsn1wK62tvSQTbZimHQVtPdNF
 a0ngn4Dx7z1zdC0GDFgI4XngEe5YAty8uUB+tcojv9nHrl3tOI5BSIggDG7bQFd3
 ltGRZYaHF5mdKVCtRrOGxPEAkf6LxRKvnz1DV1eaXC7Nq69eYmRkmlwuya6dA2xs
 6yPhbkQpJ5rCmkFEljtDdCi8bhn79h4FyCP8HpCR2G31kVJEKBRr3BpeYnmlTEuL
 QyptI0rQOhoVN3WkGdy2gYGBVtraktiOidYQBFE19gOfM2dOE+o8u3f3ceHCTc6f
 v0kiYbJv7yBdWwbJZDZjmYn14BtpAA/4BsIZgEtvrs3Gxv59R0GYB7YD90nc3KzN
 pVHuDwPN7GyBsdFlatWATNYlkbCiQ1wdtQqptENnZ5qtWzcwuG0DPT0ttG5wOXXq
 dYZuXOWee7YxPDzBL395DZGQ/fu20te7nVzLFhw7BaiI9FqLWrf+aYR/BIrfbZJP
 PY0C+MC3gMNE5/1vs0F9wC8WPc6dm2JiYpXtOzbSH1vddUy0REO4MoRMxqGlxWFy
 apRLly+wc2cPt2/PcebMFSDggYPb6OneRja7BcfJEASC5/mNote0SsC/Csxo3r6M
 i5ePsX/fUYBpICfCh0BEmupCPbAtS+G6Fq5roTUsLZWZmlxlbq5EPl+lUvHjwT0i
 PT4+zde+9p9Ylonn+Zw+/SaeV+VTn/ogjz/xYe65Zy+pVI5CIaBWDRsDTpPlAb4P
 fFPA++4Pjr6NQENwn//cMYBOEZ4GHpWmwUaIrO+4JsmkRSJp4TomdnzQZTSnTCs6
 PwWfsbHLnD13jcXFMhcvDlMsljh8eB9Hj/4We/bsoaNjM1qbnH1jkp/+5CbLyxXC
 IFw70YALaP0Z4PrTdwEP9SauzkaYAv4eGGm4Ua89mKYimbRIp2xSaZtUyiaTccjl
 XFpaXLJZl2zGwXEUr7xyhp8+/0u2b29HpEK1WuXRR3fwyU8eYsf2nbS3b8J1XFIp
 m8HBDShDosF+7WungCcRdf3dfoZZ99IX/vAY0bAffBbk3xDaGuOmQDoO0k0dadra
 kuRyLqmURTJpRceOhsKyFRcuDPHVr36LMAyZm1vgnnt66e7OcODADg4cOEBXVxem
 YVMs+dweX+XUL8a4fm0+Or2L0C9q+GsN3xHQT3//ifdGYI0EBvDHIN8Qoa0eC6IE
 yzJIJEzSsQfSaZtkyiLhWrgJkyCo8p2nnmNoaISFhVUWF1fYuXMzhw8/yED/TrLZ
 TfieYnmlyuxMkYX5EuWyH/0aVe93NE9q5Nugg3cDXwfaWEeOHMHz32Jm4Z8Rlb5i
 mZ0LIsb9IpKuyyjK6/XfunxKJZ98ocrySoWF+SIvvXyGc+cusLJSZGlpld7eNvbt
 2Yltd1IqJpidqTExkWd6qsjKStR+S6NYhWNhWHmyWDn99NWRL/mZZCvbtncyNDT0
 qz1w5MiRZlJJCHNAW8J98KOOtfXPlEoMNgd1vQeqH/ialqJQXObkyReYnZtlZaXA
 li2t7N2zg03tA6RSGxFx8P3oV5kgCIknStA6DMLimzXv5r+Xq6+/IqIWQa0A1Tq1
 48eP35WAeZfnbGAjqH5gc7lyZtnzxr6TcA/8tmlsuk+wUlqi5t73o12tBmgCrl27
 xPTMDMViiS2drWzbOkgq2YXWWcolQeOhm7OkBq2ri543cbpcu3gyDBeqIuZuYBwY
 BRaJatQ7rjsJSOyBBNHvwllQST+YKuSL8z9x7G1XHXv7A4bK7UDMVDS4RJVzbn6K
 G8NXKJXKdG3ZSH9fPy3ZbmxrA2ibMFw779Baa62ry34wf7lau/aG549PgQ7AyMbc
 0rEhf+Xv2HcS0ER9xwpRYdNAC6gEBHalduVqzbt1y7b6um2zf49htG5Tym33PM+9
 ev2iFItF+vu66OnuJZvtJJFozLJR9Gi/EISlKT+Yu+55b13z/MlZCHxQPkiVqOou
 AHNAkTvmlPcqoVp8kxowHxEgA6QFI6G151Zq12ertRuXDZXLWubmzSOj5Yenp2/t
 6u7Ozm/Z0makUhnt2FYoUq4EYaEYhuWFIFyZ9v25KT+Ynde6UATxQHmgKjHwArBK
 NJusxASCX0VgnYuaAlmIipxJdJDqxjvRdO1AaAeB51y5Uro3CCrpDRuCxXQqV81k
 W8u2ZftI4GldrWntexD6iPIE5YHUgEq8y027EhvOb7b+OwXw2wjchUgzGRXHh9m0
 Ld/37UIhnyyXiykRU2Uy6ZrruqEylBZEx//gEcSg/Fii9Uev6bWQ+gHpewD+rgTe
 A6EGMc/zVD6fN2q1muG6LqlUCsuq/7dNA5COAYZN1+ualfcC9m7r/wEd/WbYalw1
 QQAAACV0RVh0Y3JlYXRlLWRhdGUAMjAwOS0xMC0xM1QwOTozNjo0NiswMTowMKsc
 6OIAAAAldEVYdG1vZGlmeS1kYXRlADIwMDktMTAtMTFUMDE6MTU6MzgrMDE6MDDA
 rxheAAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJbWFnZVJlYWR5ccllPAAAAABJRU5E
 rkJggg==

Package: qemacs-doc
Architecture: all
Description: Documentation for qemacs
 <insert long description, indented with spaces>

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif





config.status: configure
	dh_testdir
	# Add here commands to configure the package.
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	./configure  --prefix=/usr --datadir=\$${prefix}/share --mandir=\$${prefix}/share/man   --enable-x11 --enable-xv --enable-xshm --enable-xrender


#Architecture
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp:  config.status 

	# Add here commands to compile the arch part of the package.
	#$(MAKE)
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:  config.status 

	# Add here commands to compile the indep part of the package.
	#$(MAKE) doc
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp 

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f config.sub config.guess

	dh_clean 

install: install-indep install-arch
install-indep:
	dh_testdir
	dh_testroot
	dh_clean -k -i 
	dh_installdirs -i

	# Add here commands to install the indep part of the package into
	# debian/<package>-doc.
	#INSTALLDOC#

	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -k -s 
	dh_installdirs -s

	# Add here commands to install the arch part of the package into
	# debian/tmp.
	$(MAKE) prefix=$(CURDIR)/debian/qemacs/usr install

	dh_install -s
# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs Changelog
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch

## qemacs 20250422

=== Makefile ===
# QEmacs, tiny but powerful multimode editor
#
# Copyright (c) 2000-2002 Fabrice Bellard.
# Copyright (c) 2000-2025 Charlie Gordon.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

DEPTH=.
OSNAME:=$(shell uname -s)

include $(DEPTH)/config.mak

ifeq (,$(V)$(VERBOSE))
    echo := @echo
    cmd  := @
else
    echo := @:
    cmd  :=
endif

ifeq ($(CC),gcc)
  CFLAGS  += -g -O2 -funsigned-char -Wall
  # do not warn about zero-length formats.
  CFLAGS  += -Wno-format-zero-length
  LDFLAGS += -g
endif

#include local compiler configuration file
-include $(DEPTH)/cflags.mk

ifdef CONFIG_DARWIN
  CFLAGS += -Wno-string-plus-int
  CFLAGS += -Wint-conversion
  CFLAGS += -Wno-packed
else
ifneq ($(OSNAME),OpenBSD)
  CFLAGS += -Wno-unused-result
endif
endif

ifdef TARGET_GPROF
  CFLAGS  += -p
  LDFLAGS += -p
endif

CFLAGS+=-I$(DEPTH)

ifdef TARGET_ARCH_X86
  #CFLAGS+=-fomit-frame-pointer
  ifeq ($(GCC_MAJOR),2)
    CFLAGS += -m386 -malign-functions=0
  else
    CFLAGS += -march=i386 -falign-functions=0
  endif
endif

ifeq ($(CC),$(HOST_CC))
  HOST_CFLAGS:=$(CFLAGS)
endif

DEFINES=-DHAVE_QE_CONFIG_H

########################################################
# do not modify after this

ifeq ($(CC),clang)
SANITIZE_CFLAGS := -fno-sanitize-recover=all -fno-omit-frame-pointer
else
SANITIZE_CFLAGS := -fno-omit-frame-pointer
endif
DEBUG_SUFFIX:=
ifdef DEBUG
$(info Building with debug info)
DEBUG_SUFFIX:=_debug
ECHO_CFLAGS += -DCONFIG_DEBUG
CFLAGS += -g -O0
LDFLAGS += -g -O0
endif
ifdef ASAN
$(info Building with ASan)
DEBUG_SUFFIX:=_asan
ECHO_CFLAGS += -DCONFIG_ASAN
CFLAGS += -D__ASAN__
CFLAGS += -fsanitize=address $(SANITIZE_CFLAGS) -g
LDFLAGS += -fsanitize=address $(SANITIZE_CFLAGS) -g
endif
ifdef MSAN
$(info Building with MSan)
DEBUG_SUFFIX:=_msan
ECHO_CFLAGS += -DCONFIG_MSAN
CFLAGS += -D__MSAN__
CFLAGS += -fsanitize=memory $(SANITIZE_CFLAGS) -g
LDFLAGS += -fsanitize=memory $(SANITIZE_CFLAGS) -g
endif
ifdef UBSAN
$(info Building with UBSan)
DEBUG_SUFFIX:=_ubsan
ECHO_CFLAGS += -DCONFIG_UBSAN
CFLAGS += -D__UBSAN__
CFLAGS += -fsanitize=undefined $(SANITIZE_CFLAGS) -g
LDFLAGS += -fsanitize=undefined $(SANITIZE_CFLAGS) -g
endif

TARGETLIBS:=

TOP:=0
ifeq (,$(TARGET))
TARGET:=qe
TARGETS:=kmaps ligatures tqe qe-manual.md
ifeq (,$(DEBUG_SUFFIX))
TOP:=1
endif
endif
ifeq (,$(TARGET_OBJ))
TARGET_OBJ:=$(TARGET)
endif

OBJS:= qe.o cutils.o util.o color.o charset.o buffer.o search.o input.o display.o \
       qescript.o modes/hex.o

ifdef CONFIG_32BIT
CFLAGS += -m32
LDFLAGS += -m32
endif

ifdef TARGET_TINY
ECHO_CFLAGS += -DCONFIG_TINY
CFLAGS += -DCONFIG_TINY -Os
#CFLAGS += -m32
#LDFLAGS += -m32
else
OBJS+= extras.o variables.o
endif

#ifdef CONFIG_DARWIN
#  LDFLAGS += -L/opt/local/lib/
#endif

ifdef CONFIG_PNG_OUTPUT
  HTMLTOPPM_LIBS += -lpng
endif

ifdef CONFIG_DLL
  LIBS += $(DLLIBS)
  # export some qemacs symbols
  LDFLAGS += -Wl,-E
endif

ifdef CONFIG_DOC
  TARGETS += qe-doc.html
endif

ifdef CONFIG_HAIKU
  OBJS += haiku.o
  LIBS += -lbe -lstdc++
endif

ifdef CONFIG_WIN32
  OBJS+= unix.o win32.o
#  OBJS+= printf.o
  LIBS+= -lmsvcrt -lgdi32 -lwsock32
else
  OBJS+= unix.o tty.o
  LIBS+= $(EXTRALIBS)
endif

ifndef TARGET_TINY

ifdef CONFIG_QSCRIPT
  OBJS+= qscript.o eval.o
endif

ifdef CONFIG_ALL_KMAPS
  OBJS+= kmap.o
endif

ifdef CONFIG_UNICODE_JOIN
  OBJS+= unicode_join.o arabic.o indic.o
  OBJS+= libunicode.o libregexp.o
endif

# more charsets if needed
OBJS+= charsetjis.o charsetmore.o

ifdef CONFIG_ALL_MODES
OBJS+= modes/unihex.o   modes/bufed.o    modes/orgmode.o  modes/markdown.o \
       lang/clang.o     lang/xml.o       lang/htmlsrc.o   lang/forth.o     \
       lang/arm.o       lang/lisp.o      lang/makemode.o  lang/perl.o      \
       lang/script.o    lang/ebnf.o      lang/cobol.o     lang/rlang.o     \
       lang/txl.o       lang/nim.o       lang/rebol.o     lang/elm.o       \
       lang/jai.o       lang/ats.o       lang/rust.o      lang/swift.o     \
       lang/icon.o      lang/groovy.o    lang/virgil.o    lang/ada.o       \
       lang/basic.o     lang/vimscript.o lang/pascal.o    lang/fortran.o   \
       lang/haskell.o   lang/lua.o       lang/python.o    lang/ruby.o      \
       lang/smalltalk.o lang/sql.o       lang/elixir.o    lang/agena.o     \
       lang/coffee.o    lang/erlang.o    lang/julia.o     lang/ocaml.o     \
       lang/scad.o      lang/magpie.o    lang/falcon.o    lang/wolfram.o   \
       lang/tiger.o     lang/asm.o       lang/inifile.o   lang/postscript.o \
       lang/sharp.o     lang/emf.o       lang/csv.o       lang/crystal.o   \
       lang/rye.o       lang/nanorc.o    lang/tcl.o       modes/fractal.o  \
       $(EXTRA_MODES)
ifndef CONFIG_WIN32
OBJS+= modes/shell.o    modes/dired.o    modes/archive.o  modes/latex-mode.o
endif
endif

# currently not used in qemacs
ifdef CONFIG_CFB
  OBJS+= libfbf.o fbfrender.o cfb.o fbffonts.o
endif

ifdef CONFIG_HTML
  LIBQHTML:= $(DEPTH)/.objs/$(TARGET_OS)-$(TARGET_ARCH)-$(CC)/libqhtml$(DEBUG_SUFFIX).a
  QHTML_LIBS:= -L$(DEPTH)/.objs/$(TARGET_OS)-$(TARGET_ARCH)-$(CC)/ -lqhtml$(DEBUG_SUFFIX)
  CFLAGS+= -I./libqhtml
  HOST_CFLAGS+= -I./libqhtml
  DEP_LIBS+= $(LIBQHTML)
  LIBS+= $(QHTML_LIBS)
  OBJS+= modes/html.o modes/docbook.o
  ifndef CONFIG_WIN32
    TARGETLIBS+= libqhtml
    TARGETS+= html2png$(EXE)
  endif
endif

ifdef CONFIG_FFMPEG
  OBJS+= modes/video.o modes/image.o
  DEP_LIBS+= $(FFMPEG_LIBDIR)/libavcodec/libavcodec.a $(FFMPEG_LIBDIR)/libavformat/libavformat.a
  LIBS+= -L$(FFMPEG_LIBDIR)/libavcodec -L$(FFMPEG_LIBDIR)/libavformat -lavformat -lavcodec -lz -lpthread
  DEFINES+= -I$(FFMPEG_SRCDIR)/libavcodec -I$(FFMPEG_SRCDIR)/libavformat
  TARGETS+= ffplay$(EXE)
else
  OBJS+= modes/stb.o
endif

ifdef CONFIG_X11
  TARGETS += xqe
endif

ifdef TARGET_X11
  OBJS+= x11.o
  ECHO_CFLAGS += -DCONFIG_X11
  DEFINES += -DCONFIG_X11
  CFLAGS += $(XCFLAGS)
  LDFLAGS += $(XLDFLAGS)
  LIBS += $(XLIBS)
  ifdef CONFIG_XRENDER
    LIBS += -lXrender
  endif
  ifdef CONFIG_XV
    LIBS += -lXv
  endif
  ifdef CONFIG_XSHM
    LIBS += -lXext
  endif
  LIBS += -lX11 $(DLLIBS)
endif
endif	# TARGET_TINY

SRCS:= $(OBJS:.o=.c)

DEPENDS:= qe.h config.h config.mak charset.h color.h cutils.h display.h \
	qestyles.h unicode_join.h util.h variables.h \
	wcwidth.h lang/clang.h

DEPENDS:= $(addprefix $(DEPTH)/, $(DEPENDS))

BINDIR:=$(DEPTH)/bin

OBJS_DIR:= $(DEPTH)/.objs/$(TARGET_OS)-$(TARGET_ARCH)-$(CC)/$(TARGET_OBJ)$(DEBUG_SUFFIX)
CFLAGS+= -I$(OBJS_DIR)
OBJS:= $(addprefix $(OBJS_DIR)/, $(OBJS))
OBJS+= $(OBJS_DIR)/$(TARGET)_modules.o

#
# Dependencies
#
ifeq (1,$(TOP))
all: $(TARGETLIBS) $(TARGET)$(DEBUG_SUFFIX)$(EXE) $(TARGETS)
else
all: $(TARGETLIBS) $(TARGET)$(DEBUG_SUFFIX)$(EXE)
endif

libqhtml: force
	$(MAKE) -C libqhtml all

ifneq (,$(DEBUG_SUFFIX))
$(TARGET)$(DEBUG_SUFFIX)$(EXE): $(OBJS) $(DEP_LIBS)
	$(echo) LD $@
	$(cmd)  $(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
else
$(TARGET)_g$(EXE): $(OBJS) $(DEP_LIBS)
	$(echo) LD $@
	$(cmd)  $(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

$(TARGET)$(EXE): $(TARGET)_g$(EXE) Makefile
	@rm -f $@
	cp $< $@
	-$(STRIP) $@
	@ls -l $@
	@echo `$(SIZE) $@` `wc -c $@` $(TARGET) $(OPTIONS) \
		| cut -d ' ' -f 7-10,13,15-40 >> STATS
endif

ifeq (1,$(TOP))

# targets that require recursion
xqe:		force;	$(MAKE) TARGET=xqe TARGET_OBJ=qe TARGET_X11=1
tqe:		force;	$(MAKE) TARGET=tqe TARGET_TINY=1
tqe1:		force;	$(MAKE) TARGET=tqe TARGET_TINY=1 tqe1$(EXE)
asan qe_asan:	force;	$(MAKE) TARGET=qe ASAN=1
msan qe_msan:	force;	$(MAKE) TARGET=qe MSAN=1
ubsan qe_ubsan:	force;	$(MAKE) TARGET=qe UBSAN=1
debug qe_debug:	force;	$(MAKE) TARGET=qe DEBUG=1
xqe_debug:	force;	$(MAKE) TARGET=xqe TARGET_OBJ=qe TARGET_X11=1 DEBUG=1
tqe_debug:	force;	$(MAKE) TARGET=tqe TARGET_TINY=1 DEBUG=1

else

# Amalgation mode produces a larger executable
TSRCS:=qe.c cutils.c util.c color.c charset.c buffer.c search.c input.c display.c \
       modes/hex.c parser.c unix.c tty.c win32.c qeend.c
TSRCS+= $(OBJS_DIR)/tqe_modules.c

tqe1_g$(EXE): tqe.c $(TSRCS) Makefile
	$(echo) CC $(ECHO_CFLAGS) -o $@ $<
	$(cmd)  $(CC) $(DEFINES) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)

tqe1$(EXE): tqe1_g$(EXE) Makefile
	@rm -f $@
	cp $< $@
	-$(STRIP) $@
	@ls -l $@
	@echo `$(SIZE) $@` `wc -c $@` tqe1 $(OPTIONS) \
		| cut -d ' ' -f 7-10,13,15-40 >> STATS
endif

ifdef CONFIG_FFMPEG
ffplay$(EXE): qe$(EXE) Makefile
	ln -sf $< $@
endif

$(OBJS_DIR)/$(TARGET)_modules.o: $(OBJS_DIR)/$(TARGET)_modules.c Makefile
	$(echo) CC $(ECHO_CFLAGS) -c $<
	$(cmd)  $(CC) $(DEFINES) $(CFLAGS) -o $@ -c $<

$(OBJS_DIR)/$(TARGET)_modules.c: $(SRCS) Makefile config.mak
	@echo creating $@
	$(cmd)  mkdir -p $(dir $@)
	@echo '/* This file was generated automatically */' > $@
	@echo '#include "qe.h"'                             >> $@
	@echo '#undef qe_module_init'                       >> $@
	@echo '#define qe_module_init(fn)  extern int qe_module_##fn(QEmacsState *qs)' >> $@
	-@grep -h ^qe_module_init $(SRCS)                   >> $@
	@echo '#undef qe_module_init'                       >> $@
	@echo 'void qe_init_all_modules(QEmacsState *qs) {' >> $@
	@echo '#define qe_module_init(fn)  qe_module_##fn(qs)' >> $@
	-@grep -h ^qe_module_init $(SRCS)                   >> $@
	@echo '#undef qe_module_init'                       >> $@
	@echo '}'                                           >> $@
	@echo '#undef qe_module_exit'                       >> $@
	@echo '#define qe_module_exit(fn)  extern void qe_module_##fn(QEmacsState *qs)' >> $@
	-@grep -h ^qe_module_exit $(SRCS)                   >> $@
	@echo '#undef qe_module_exit'                       >> $@
	@echo 'void qe_exit_all_modules(QEmacsState *qs) {' >> $@
	@echo '#define qe_module_exit(fn)  qe_module_##fn(qs)' >> $@
	-@grep -h ^qe_module_exit $(SRCS)                   >> $@
	@echo '#undef qe_module_exit'                       >> $@
	@echo '}'                                           >> $@

$(OBJS_DIR)/cfb.o: cfb.c cfb.h fbfrender.h
$(OBJS_DIR)/charset.o: charset.c wcwidth.c
$(OBJS_DIR)/charsetjis.o: charsetjis.c charsetjis.def
$(OBJS_DIR)/fbfrender.o: fbfrender.c fbfrender.h libfbf.h
$(OBJS_DIR)/modes/stb.o: modes/stb.c modes/stb_image.h
$(OBJS_DIR)/libunicode.o: libunicode.c libunicode.h libunicode-table.h
$(OBJS_DIR)/libregexp.o: libregexp.c libregexp.h libregexp-opcode.h

$(OBJS_DIR)/%.o: %.c $(DEPENDS) Makefile
	$(echo) CC $(ECHO_CFLAGS) -c $<
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  $(CC) $(DEFINES) $(CFLAGS) -o $@ -c $<

$(OBJS_DIR)/haiku.o: haiku.cpp $(DEPENDS) Makefile
	$(echo) CPP $(ECHO_CFLAGS) -c $<
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  g++ $(DEFINES) $(CFLAGS) -Wno-multichar -o $@ -c $<

# debugging targets
%.s: %.c $(DEPENDS) Makefile
	$(CC) $(DEFINES) $(CFLAGS) -o $@ -S $<

%.s: %.cpp $(DEPENDS) Makefile
	g++ $(DEFINES) $(CFLAGS) -Wno-multichar -o $@ -S $<

#
# Host utilities
#
$(BINDIR)/%$(EXE): tools/%.c
	$(echo) CC -o $@ $^
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  $(HOST_CC) $(HOST_CFLAGS) -o $@ $^

#
# build ligature table
#
$(BINDIR)/ligtoqe$(EXE): tools/ligtoqe.c cutils.c
	$(echo) CC -o $@ $^
	$(cmd)  mkdir -p $(dir $@)
	$(cmd)  $(HOST_CC) $(HOST_CFLAGS) -o $@ $^

ifdef BUILD_ALL

=== plugins/Makefile ===
#
# QEmacs sample Makefile to develop plugins
#
# QEmacs plugins can contain modes, bindings, or any other qemacs
# dynamically registerable resource.
#

# modify to get the path of the qemacs sources
QEMACS_PATH=../
# define the name of your plugin
LIB=my_plugin.so
# define the object files it contains
OBJS=my_plugin.o

INCLUDES=-I$(QEMACS_PATH)
DEFINES=-DQE_MODULE
DIST_LIB:=$(HOME)/.qe/$(LIB)
CC=gcc
CFLAGS=-O2 -Wall -g -fPIC $(INCLUDES) $(DEFINES)

# by default, the plugin is copied in ~/.qe/ some that qemacs can load
# it automatically.
all: $(DIST_LIB)

$(DIST_LIB): $(LIB)
	install -s -m 644 $< $@

install: $(DIST_LIB)

$(LIB): $(OBJS) Makefile
	$(CC) -shared -o $@ $(OBJS)

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

clean:
	rm -f *.o *.so *~
